--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/cnc1900_power_clk.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/cnc1900_power_clk.c	2015-05-21 18:59:42.256307000 +0800
@@ -0,0 +1,1434 @@
+#include <linux/types.h>
+#include <asm/io.h>
+#include <linux/delay.h>
+#include <linux/device.h>
+#include <linux/export.h>
+#include <linux/fs.h>
+#include <linux/module.h>
+#include <linux/clk.h>
+#include <linux/ctype.h>
+#include <linux/spinlock.h>
+#include <linux/miscdevice.h>
+#include <linux/proc_fs.h>
+#include <linux/sched.h>
+#include <mach/cnc1900_clock_reg.h>
+#include <mach/cnc1900_power_clk.h>
+
+#define FREQ_REF    27.0      //MHz
+#define VCO_MAX     3600.0
+#define VCO_MIN     1800.0
+
+struct __u__kvpair {
+	unsigned value;
+	char *string;
+};
+
+struct __u__kvpair pwr_ioctls[] = {
+	{ USB_POWER_DOWN, "USB_POWER_DOWN" },
+	{ XPORT_CLK_DOWN, "XPORT_CLK_DOWN" },
+	{ VIB_CLK_DOWN, "VIB_CLK_DOWN" },
+	{ VPB_CLK_DOWN, "VPB_CLK_DOWN" },
+	{ AUD_CLK_DOWN, "AUD_CLK_DOWN" },
+	{ CRYPTO_CLK_DOWN, "CRYPTO_CLK_DOWN" },
+	{ GRAPHICS_CLK_DOWN, "GRAPHICS_CLK_DOWN" },
+	{ DF_CLK_DOWN, "DF_CLK_DOWN" },
+	{ VIDECOD_CLK_DOWN, "VIDECOD_CLK_DOWN" },
+	{ AUDDACIF_CLK_DOWN, "AUDDACIF_CLK_DOWN" },
+	{ SD_CLK_DOWN, "SD_CLK_DOWN" },
+	{ TVE1_CLK_DOWN, "TVE1_CLK_DOWN" },
+	{ TVE0_CLK_DOWN, "TVE0_CLK_DOWN" },
+	{ AUD_POWER_DOWN, "AUD_POWER_DOWN" },
+	{ VID_POWER_DOWN, "VID_POWER_DOWN" },
+	{ AUD_PLLCLK_DOWN, "AUD_PLLCLK_DOWN" },
+	{ VDAC0_POWER_DOWN, "VDAC0_POWER_DOWN" },
+	{ VDAC1_POWER_DOWN, "VDAC1_POWER_DOWN" },
+	{ HDMI_POWER_DOWN, "HDMI_POWER_DOWN" },
+    { JPEG_CLK_DOWN, "JPEG_CLK_DOWN" },
+    { AHB2_CLK_DOWN, "AHB2_CLK_DOWN" },
+    { CEC_CLK_DOWN, "CEC_CLK_DOWN" },
+    { IR_CLK_DOWN, "IR_CLK_DOWN" },
+    { VPBIN_CLK_DOWN, "VPBIN_CLK_DOWN" },
+	{ 0, NULL },
+	{ 0, "<undefined ioctl>" }
+};
+
+volatile unsigned char  *power_clk_base = NULL;
+// volatile uint32_t       *power_clk_base_ui = NULL;
+
+DEFINE_SPINLOCK(cnc_pwr_lock);
+#define power_clk_write(a,v) writel(v,power_clk_base+((a)&0xfff))
+#define power_clk_read(a)    readl(power_clk_base+((a)&0xfff))
+
+static char *ioctl_name(unsigned cmd)
+{
+	struct __u__kvpair *iter;
+	for (iter = &pwr_ioctls[0]; iter->string != NULL; ++iter) {
+		if (iter->value == cmd) {
+			goto done;
+		}
+	}
+	++iter;
+done:
+	return iter->string;
+}
+
+
+//Coda PLL
+void InitCodaplldiv(    unsigned long  codapll_div_q   ,
+                        unsigned long  codapll_div_f   ,
+                        unsigned short codaaclk_postdiv,
+                        unsigned short codacclk_postdiv,
+                        unsigned short use_codapll_for_cclk  )
+{
+    unsigned int   data;
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN) & 0xFFFEFFFF;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //disable coda aclk & cclk
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N) & 0xFFFFFF3F;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //coda pll & divider reset
+
+    if(use_codapll_for_cclk) {
+      data = (power_clk_read(CLK_SRC_SEL) & 0xFF3FFFFF) | 0x00800000;
+      power_clk_write(CLK_SRC_SEL, data);
+    }
+
+    power_clk_write(PLL_CODA_PARA_Q, codapll_div_q);
+    power_clk_write(PLL_CODA_PARA_F, codapll_div_f);    //coda pll parameter
+    data = (power_clk_read(CLOCK_CLK_GEN_DIV) & 0xFF1FFFFF) | (codaaclk_postdiv << 21) ;
+    power_clk_write(CLOCK_CLK_GEN_DIV, data);     //coda aclk post divider
+
+    data = (power_clk_read(CLOCK_PLL_AVS_DIV) & 0xFFFFFFF0) | codacclk_postdiv ;
+    power_clk_write(CLOCK_PLL_AVS_DIV, data);     //aud cclk post divider
+
+    udelay(2);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000040;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert coda pll reset
+
+    udelay(70);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000080;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert coda divider reset
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) | 0x00010000;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //enable coda aclk & cclk
+
+}
+
+#if 0
+static unsigned long __ceil(double value)
+{
+	double temp_val = 0;
+	unsigned long a = (unsigned long)value;
+	unsigned long ret_val = 0;
+
+	temp_val = value - (double)a;
+	if(temp_val <= 0){
+		ret_val = a;
+	}
+	else{
+		ret_val = a+1;
+	}
+
+	return ret_val;
+}
+
+void abit_fnpll_calc(double fin, double fout, double vmin, double vmax, unsigned long *iDIVF, unsigned long *iDIVQ)
+{
+	const long long i4G = (1LL << 32);
+	//unsigned long iDIVF, iDIVQ;
+	double fDIVQ_PLUS1_MAX, fDIVQ_PLUS1_MIN;
+	double vco;
+
+	fDIVQ_PLUS1_MAX = vmax / (2 * fout);
+	fDIVQ_PLUS1_MIN = vmin / (2 * fout);
+
+	if( fDIVQ_PLUS1_MAX < 1 ||  fDIVQ_PLUS1_MIN > 32) {
+		return;
+	}
+
+	*iDIVQ = fDIVQ_PLUS1_MIN < 1 ? 0 : (unsigned long)__ceil(fDIVQ_PLUS1_MIN - 1);
+
+	vco = fout * ((*iDIVQ + 1) << 1);
+	*iDIVF = (unsigned long) (fin * i4G / vco);
+//	pllout = fin * i4G / (*iDIVF * ((*iDIVQ + 1) << 1));
+
+	return;
+}
+#endif
+void clock_coda_setclock(double codapll_clk, unsigned short codaaclk_postdiv, unsigned short codacclk_postdiv, unsigned short use_codapll_for_cclk )
+{
+        unsigned long CodaPLL_DIVF = 0;
+        unsigned long CodaPLL_DIVQ = 0;
+
+        printk("Coda PLL output frequency in MHz = %f\n", codapll_clk);
+
+ //       abit_fnpll_calc(FREQ_REF, codapll_clk, VCO_MIN, VCO_MAX, &CodaPLL_DIVF, &CodaPLL_DIVQ);
+
+        InitCodaplldiv( CodaPLL_DIVQ   ,
+                        CodaPLL_DIVF   ,
+                        codaaclk_postdiv ,
+                        codacclk_postdiv ,
+                        use_codapll_for_cclk);
+}
+
+enum disp0_pll_cfg {
+   target_freq       ,
+   ref_div           ,
+   fbdiv             ,
+   postdiv1          ,
+   postdiv2          ,
+   disp0_div         ,
+   disp0_clk0_div     ,
+   disp0_clk234_div   ,
+   disp0_clk6_div
+};
+//Display
+static const unsigned int disp0_pll_cfg[70][9] =
+{   //target_freq   ref_div  fbdiv  postdiv1  postdiv2  disp0_div  disp0_clk0_div  disp0_clk234_div  disp0_clk6_div
+    {  148500000,      1,      99,     4,       2,         2,          0,            0,               0 },          //
+    {  148500000,      1,      99,     4,       2,         2,          0,            0,               0 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+                                                                                                                			//
+    {  148351648,     13,    1125,     7,       1,         2,          2,            2,               4 },          // 6,
+    {   74175824,     13,    1125,     7,       1,         4,          2,            2,               4 },          // ,
+    {   74175824,     13,    1125,     7,       1,         4,          2,            2,               4 },          // ,
+    {   74175824,     13,    1125,     7,       1,         4,          2,            2,               4 },          // ,
+    {   74175824,     13,    1125,     7,       1,         4,          2,            2,               4 },          // ,
+                                                                                                                //
+    {   27000000,      1,      63,     7,       2,         4,          2,            2,               2 },          //
+    {   27000000,      1,      63,     7,       2,         4,          2,            2,               2 },          //
+    {   27027000,     20,    1802,     5,       4,         4,          2,            2,               2 },          //
+
+#if 1
+    {   13500000,      1,      63,     7,       2,         8,          2,            2,               4 },          //
+    {   13500000,      1,      63,     7,       2,         8,          2,            2,               4 },          //
+    {   13513500,     20,    1802,     5,       4,         8,          2,            2,               4 },        
+#else
+    {   13500000,      1,      63,     7,       2,         4,          2,            2,               4 },          //
+    {   13500000,      1,      63,     7,       2,         4,          2,            2,               4 },          //
+    {   13513500,     20,    1802,     5,       4,         4,          2,            2,               4 },          // ,
+#endif                                                                                                                //
+    {   31500000,      1,      84,     4,       2,         8,          0,            0,               0 },          // 00,
+    {   31500000,      1,      84,     4,       2,         8,          0,            0,               0 },          // 00,
+    {   35500000,      1,      71,     6,       1,         8,          0,            0,               0 },          // 00,
+    {   25200000,     1,    84,     5,       2,         8,          0,            0,               0 },
+    {   31500000,      1,      84,     4,       2,         8,          0,            0,               0 },          // 00,
+    {   31500000,      1,      84,     4,       2,         8,          0,            0,               0 },          // 00,
+    {   36000000,      1,      60,     5,       2,         4,          0,            0,               0 },          //
+    {   36000000,      1,      60,     5,       2,         4,          0,            0,               0 },          //
+    {   40000000,      1,      90,     6,       3,         3,          0,            0,               0 },          //
+    {   50000000,      1,      50,     4,       3,         2,          0,            0,               0 },          //
+    {   49500000,      1,      99,     4,       3,         4,          0,            0,               0 },          //
+    {   56250000,      1,      75,     4,       2,         4,          0,            0,               0 },          //
+    {   73250000,      4,     293,     4,       2,         3,          0,            0,               0 },          //
+                                                                                                                //
+    {   33750000,      1,      90,     4,       2,         8,          0,            0,               0 },          //
+                                                                                                                //
+    {   44900000,      6,     449,     5,       4,         2,          0,            0,               0 },          //
+    {   65000000,      1,      65,     4,       2,         3,          0,            0,               0 },          //
+    {   75000000,      1,      75,     4,       2,         3,          0,            0,               0 },          //
+    {   78750000,      2,     105,     4,       2,         2,          0,            0,               0 },          //
+    {   94500000,      1,      63,     4,       2,         2,          0,            0,               0 },          //
+    {  115500000,      1,      77,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                //
+    {  108000000,      1,      72,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                //
+    {   68250000,      2,      91,     4,       2,         2,          0,            0,               0 },          //
+    {   79500000,      1,      53,     4,       2,         2,          0,            0,               0 },          //
+    {  102250000,      6,     409,     4,       2,         2,          0,            0,               0 },          //
+    {  117500000,      3,     235,     4,       2,         2,          0,            0,               0 },          //
+    {  104250000,      2,     139,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                //
+    {   71000000,      1,      71,     4,       2,         3,          0,            0,               0 },          //
+    {   83500000,      2,     167,     4,       2,         3,          0,            0,               0 },          //
+    {  106500000,      1,      71,     4,       2,         2,          0,            0,               0 },          //
+    {  122500000,      3,     245,     4,       2,         2,          0,            0,               0 },          //
+    {  146250000,      2,     195,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                //
+    {  108000000,      1,      72,     4,       2,         2,          0,            0,               0 },          //
+    {  148500000,      1,      99,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {  108000000,      1,      72,     4,       2,         2,          0,            0,               0 },          //
+    {  135000000,      1,      45,     4,       1,         2,          0,            0,               0 },          //
+    {  157500000,      2,     105,     4,       1,         2,          0,            0,               0 },          //
+                                                                                                                //
+    {   85500000,      1,      57,     4,       2,         2,          0,            0,               0 },          //
+    {  148250000,      8,     593,     6,       1,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {  101000000,      3,     202,     4,       2,         2,          0,            0,               0 },          //
+    {  121750000,      6,     487,     4,       2,         2,          0,            0,               0 },          //
+    {  156000000,      1,      52,     4,       1,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {   88750000,      4,     355,     4,       2,         3,          0,            0,               0 },          //
+    {  106500000,      1,      71,     4,       2,         2,          0,            0,               0 },          //
+    {  136750000,      8,     547,     6,       1,         2,          0,            0,               0 },          //
+    {  157000000,      2,     157,     6,       1,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {  162000000,      1,      81,     6,       1,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {  119000000,      6,     476,     4,       2,         2,          0,            0,               0 },          //
+    {  146250000,      2,     195,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {  154000000,      2,     154,     6,       1,         2,          0,            0,               0 },           //
+
+    {   25175000,     20,    1007,     6,       1,         8,          0,            0,               0 },          //
+
+
+};
+
+void clock_disp0_setclock(CLOCK_DISP0_MODE mode_disp0)
+{
+    unsigned int   div_m               = 0;
+    unsigned int   div_fb              = 0;
+    unsigned int   div_fb_29_27;
+    unsigned int   div_fb_25_23;
+    unsigned int   div_fb_19_17;
+    unsigned int   div_fb_16_13;
+    unsigned int   div_fb_9_8;
+    unsigned int   div_fb_7_5;
+    unsigned int   div_fb_3_1;
+    unsigned int   data;
+    div_m  = (disp0_pll_cfg[mode_disp0][fbdiv] & 0xE00) >> 9;
+    div_fb_29_27 = (disp0_pll_cfg[mode_disp0][fbdiv] & 0x1C0) << 21;
+    div_fb_25_23 = (disp0_pll_cfg[mode_disp0][fbdiv] & 0x038) << 20;
+    div_fb_19_17 = (disp0_pll_cfg[mode_disp0][fbdiv] & 0x007) << 17;
+    div_fb_16_13 = (disp0_pll_cfg[mode_disp0][ref_div] & 0x00f) << 13;
+    div_fb_9_8   = (disp0_pll_cfg[mode_disp0][ref_div] & 0x030) << 4;
+    div_fb_7_5   = (disp0_pll_cfg[mode_disp0][postdiv1] & 0x007) << 5;
+    div_fb_3_1   = (disp0_pll_cfg[mode_disp0][postdiv2] & 0x007) << 1;
+
+    div_fb       = div_fb_29_27 | div_fb_25_23 | div_fb_19_17 | div_fb_16_13 | div_fb_9_8 | div_fb_7_5 | div_fb_3_1;
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) & 0xFFFFFFEF;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //disable tve clock, disp clock
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) & 0xFFFFFFFC;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //tve pll & divider reset
+
+    power_clk_write(PLL_TVE_PARA_Q, div_m);
+    power_clk_write(PLL_TVE_PARA_F, div_fb);    //tve pll parameter
+    data = power_clk_read(CLOCK_TVE_DIV_N ) & 0x0FFFF000;
+    power_clk_write(CLOCK_TVE_DIV_N, (data | (disp0_pll_cfg[mode_disp0][disp0_clk234_div] << 28) | (disp0_pll_cfg[mode_disp0][disp0_div] << 8) | (disp0_pll_cfg[mode_disp0][disp0_clk6_div] << 4) | disp0_pll_cfg[mode_disp0][disp0_clk0_div]));    //tve divider
+
+    udelay(2);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000001;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert tve pll reset
+
+    udelay(70);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000002;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert tve divider reset
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) | 0x00000010;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //enable tve clock, disp clock
+
+}
+
+enum disp1_pll_postdiv {
+   target_freq_disp1  ,
+   sys_div          ,
+   disp1_div         ,
+   disp1_clk0_div     ,
+   disp1_clk234_div   ,
+   disp1_clk6_div
+};
+
+static const unsigned int disp1_cfg[8][6] =
+{   //target_freq    sys_div  disp1_div  disp1_clk0_div  disp1_clk234_div  disp1_clk6_div
+    {   27000000,       10,        4,          2,            2,               2 },          //  576P
+    {   27000000,       10,        4,          2,            2,               2 },          //   480P
+    {   27000000,       10,        4,          2,            2,               4 },          //   PAL
+    {   27000000,       10,        4,          2,            2,               4 },          //    NTSL
+    {   27000000,       10,        4,          2,            2,               4 },          //   SECAM
+    {   27000000,       10,        4,          2,            2,               4 },          //   PAL_M
+    {   27000000,       10,        4,          2,            2,               4 },          //   PAL_N
+    {   27000000,       10,        4,          2,            2,               4 },          //    PAL_CN
+};
+
+void clock_disp1_setclock(CLOCK_DISP1_MODE mode_disp1)
+{
+    unsigned int   data;
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) & 0xFFFFFFDF;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //disable tve clock, disp clock
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) & 0xFFFFFFFD;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //tve divider reset
+
+    data = (power_clk_read(CLK_SRC_SEL ) & 0xFFF0FFFF) | 0x00050000;
+    power_clk_write(CLK_SRC_SEL, data);        //select sys pll as disp1 clock source
+
+    data = power_clk_read(CLOCK_TVE_DIV_N ) & 0xF0000FFF;
+    power_clk_write(CLOCK_TVE_DIV_N, (data | (disp1_cfg[mode_disp1][disp1_div] << 24) | (disp1_cfg[mode_disp1][disp1_clk6_div] << 20) | (disp1_cfg[mode_disp1][disp1_clk234_div] << 16) | (disp1_cfg[mode_disp1][disp1_clk0_div] << 12)));    //tve divider
+
+    data = power_clk_read(CLOCK_CLK_GEN_DIV ) & 0xFFFF03FF;
+    power_clk_write(CLOCK_CLK_GEN_DIV, (data | (disp1_cfg[mode_disp1][sys_div] << 10)) );    //cpu/sys  divider
+
+    udelay(10);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000002;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert tve divider reset
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) | 0x00000020;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //enable tve clock, disp clock
+
+}
+
+enum aud_pll_postdiv {
+   aud_target_freq      ,
+   audpll_div_F         ,
+   audpll_div_Q         ,
+   audclk_postdiv
+};
+#if 0
+static const unsigned int aud_pll_cfg[13][4] =
+{   //target_freq  audpll_div_F  audpll_div_Q  audclk_postdiv 
+    {  192000,      58982400,      9,                  2     },       
+    {   96000,      62086737,     18,                  2     },       
+    {   88200,      64198531,     19,                  2     },       
+    {   64000,      63195429,     27,                  2     },       
+    {   48000,      58982400,     19,                  2     },       
+    {   44100,      33349886,     10,                  7     },       
+    {   32000,      58982400,     29,                  2     },       
+    {   24000,      62086737,     18,                  8     },       
+    {   22050,      64198531,     19,                  8     },       
+    {   16000,      63195429,     13,                  8     },       
+    {   12000,      62086737,     18,                 16     },       
+    {   11025,      64198531,     19,                 16     },       
+    {    8000,      63195429,     27,                 16     }        
+};
+#endif
+
+static const unsigned int aud_pll_cfg[16][4] =
+{   //target_freq  audpll_div_F  audpll_div_Q  audclk_postdiv 
+	{  192000,      32768000,      8,                  2     },   
+	{  176400,      35665850,      8,                  2     }, 
+	{  128000,      32768000,      8,                  3     }, 
+	{   96000,      32768000,     17,                  2     },   
+	{   88200,      64198531,     19,                  2     },            
+	{   64000,      32768000,     26,                  2     },       
+	{   48000,      32768000,     23,                  3     },       
+	{   44100,      33349886,     10,                  7     },       
+	{   32000,      32768000,     26,                  4     }, 
+	{   24000,      62086737,     18,                  8     },       
+	{   22050,      64198531,     19,                  8     },       
+	{   16000,      32768000,     26,                  8     }, 
+	{   12000,      62086737,     18,                 16     },       
+	{   11025,      64198531,     19,                 16     },       
+	{    8000,      63195429,     27,                 16     }      
+};
+
+void clock_audio_setclock(AUDIO_CLOCK_MODE audclk_rate)
+{
+    unsigned int   data;
+
+   // printk("CNC1900 Audio Target freq = %d\n", aud_pll_cfg[audclk_rate][aud_target_freq]);
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) & 0xFFFFF7FF;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //disable audio pcm clock
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) & 0xFFFFFFCF;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //aud pll & divider reset
+
+    power_clk_write(PLL_AUD_PARA_Q, aud_pll_cfg[audclk_rate][audpll_div_Q]);
+    power_clk_write(PLL_AUD_PARA_F, aud_pll_cfg[audclk_rate][audpll_div_F]);
+    power_clk_write(CLOCK_AUD_DIV, aud_pll_cfg[audclk_rate][audclk_postdiv]);
+
+    udelay(2);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000010;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert audio pll reset
+
+    udelay(70);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000030;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert audio divider reset
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) | 0x00000800;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //enable audio pcm clock
+
+}
+
+void clock_alsa_setclock(int rate)
+{
+	int i;
+    unsigned int data;
+
+	for (i = 0; i < 13; i++) {
+		if (aud_pll_cfg[i][0] == rate)
+			break;
+	}
+
+	if (i == 13)
+		return;
+
+   // printk("CNC1900 Audio Target freq = %d\n", aud_pll_cfg[audclk_rate][aud_target_freq]);
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) & 0xFFFFF7FF;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //disable audio pcm clock
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) & 0xFFFFFFCF;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //aud pll & divider reset
+
+    power_clk_write(PLL_AUD_PARA_Q, aud_pll_cfg[i][audpll_div_Q]);
+    power_clk_write(PLL_AUD_PARA_F, aud_pll_cfg[i][audpll_div_F]);
+    power_clk_write(CLOCK_AUD_DIV,  aud_pll_cfg[i][audclk_postdiv]);
+
+    udelay(2);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000010;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert audio pll reset
+
+    udelay(70);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000030;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert audio divider reset
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) | 0x00000800;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //enable audio pcm clock
+
+}
+void clock_xport_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<1)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<1));
+    }
+
+    return;
+}
+
+void clock_ether_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<2)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<2));
+    }
+
+    return;
+}
+
+void clock_audio_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<3)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<3));
+    }
+
+    return;
+}
+
+void clock_crypto_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<5)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<5));
+    }
+
+    return;
+}
+
+void clock_video_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<6)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<6));
+    }
+
+    return;
+}
+
+void clock_gfx_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<7)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<7));
+    }
+
+    return;
+}
+
+void clock_dfr_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<11)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<11));
+    }
+
+    return;
+}
+
+void clock_disp0_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<12)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<12));
+    }
+
+    return;
+}
+
+void clock_disp1_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<13)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<13));
+    }
+
+    return;
+}
+
+void clock_tve0_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<14)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<14));
+    }
+
+    return;
+}
+
+void clock_tve1_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<15)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<15));
+    }
+
+    return;
+}
+
+void clock_vib_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<16)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<16));
+    }
+
+    return;
+}
+
+void clock_jpeg_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<17)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<17));
+    }
+
+    return;
+}
+
+void clock_coda_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<18)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<18));
+    }
+
+    return;
+}
+
+void clock_hdmi_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<19)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<19));
+    }
+
+    return;
+}
+
+void clock_hdmi_bypass(HDMI_SEL vpbOrdisp)
+{
+    unsigned int reg_val;
+
+    if (vpbOrdisp==_sel_ttl) {
+        reg_val = power_clk_read(CLOCK_HDMI_CLK_SEL);
+        power_clk_write(CLOCK_HDMI_CLK_SEL, reg_val&(~(0x1<<0)));
+    } else {
+        reg_val = power_clk_read(CLOCK_HDMI_CLK_SEL);
+        power_clk_write(CLOCK_HDMI_CLK_SEL, reg_val|(0x1<<0));
+    }
+
+    return;
+}
+void clock_spdif_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<20)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<20));
+    }
+
+    return;
+}
+
+void clock_dramporta_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<21)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<21));
+    }
+
+    return;
+}
+
+void clock_ir_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<22)));
+    } else {
+        reg_val = power_clk_read(CLOCK_SOFT_RESET);
+        power_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<22));
+    }
+
+    return;
+}
+
+void clock_dac0_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if(ClockEna == _clock_disable){
+		reg_val = power_clk_read(VDAC0_CTRL);
+		power_clk_write(VDAC0_CTRL, reg_val&(~(0x7<<3)));
+	}
+	else{
+		reg_val = power_clk_read(VDAC0_CTRL);
+		power_clk_write(VDAC0_CTRL, reg_val|(0x7<<3)|0xfffffc0);
+
+	}
+	return;
+}
+
+void clock_dac1_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if(ClockEna == _clock_disable){
+		reg_val = power_clk_read(VDAC1_CTRL);
+		power_clk_write(VDAC1_CTRL, reg_val&(~(0x7<<3)));
+	}
+	else{
+		reg_val = power_clk_read(VDAC1_CTRL);
+		power_clk_write(VDAC1_CTRL, reg_val|(0x1<<3)|0xfffffc0);
+	}
+	return;
+}
+
+void clock_dram_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<1)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<1));
+	}
+	return;
+}
+
+void clock_tve0_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<4)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<4));
+	}
+	return;
+}
+
+void clock_tve1_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<5)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<5));
+	}
+	return;
+}
+
+void clock_sdio_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<7)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<7));
+	}
+	return;
+}
+
+void clock_audiopll_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<11)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<11));
+	}
+	return;
+}
+
+void clock_jpeg_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<15)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<15));
+	}
+	return;
+}
+
+void clock_coda_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<16)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<16));
+	}
+	return;
+}
+
+void clock_df_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<17)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<17));
+	}
+	return;
+}
+
+void clock_gpu_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<18)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<18));
+	}
+	return;
+}
+
+void clock_ahb2_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<19)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<19));
+	}
+	return;
+}
+
+void clock_crypto_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<20)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<20));
+	}
+	return;
+}
+
+void clock_xport_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<21)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<21));
+	}
+	return;
+}
+
+void clock_audio_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<22)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<22));
+	}
+	return;
+}
+
+void clock_video_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<23)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<23));
+	}
+	return;
+}
+void clock_dramporta_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<24)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<24));
+	}
+	return;
+}
+
+void clock_usb_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<25)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<25));
+	}
+	return;
+}
+
+void clock_cec_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<26)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<26));
+	}
+	return;
+}
+
+void clock_ir_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<27)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_AVS_DIV);
+		power_clk_write(CLOCK_PLL_AVS_DIV, (reg_val&(~((0xf<<25)))) | (0x8<<25) ); // change to 135MHz IR clock
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<27));
+	}
+	return;
+}
+
+void clock_vpb_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<28)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<28));
+	}
+	return;
+}
+
+void clock_vpbinput_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<29)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<29));
+	}
+	return;
+}
+
+void clock_cpu_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<30)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<30));
+	}
+	return;
+}
+
+void clock_cpusrc_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<31)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<31));
+	}
+	return;
+}
+
+void clock_hdmi_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int clock_reset_state_before = 0, clock_reset_state_after = 0;
+
+	clock_reset_state_before = power_clk_read(CLOCK_CLK_RESET);
+	if (ClockEna == _clock_disable) {
+		clock_reset_state_after = clock_reset_state_before & ~(3 << 2);
+		printk(KERN_INFO "turn OFF HDMI clock: (0x%08x): before=%08x, after=%08x\n", CLOCK_CLK_RESET, clock_reset_state_before, clock_reset_state_after);
+	} else {
+		clock_reset_state_after = clock_reset_state_before | (3 << 2);
+		printk(KERN_INFO "turn ON HDMI clock: (0x%08x): before=%08x, after=%08x\n", CLOCK_CLK_RESET, clock_reset_state_before, clock_reset_state_after);
+	}
+	power_clk_write(CLOCK_CLK_RESET, clock_reset_state_after);
+	return;
+}
+
+EXPORT_SYMBOL(clock_hdmi_reset);
+EXPORT_SYMBOL(clock_disp0_setclock);
+EXPORT_SYMBOL(clock_disp1_setclock);
+EXPORT_SYMBOL(clock_audio_setclock);
+EXPORT_SYMBOL(clock_dac0_enaclock);
+EXPORT_SYMBOL(clock_dac1_enaclock);
+EXPORT_SYMBOL(clock_dram_enaclock);
+EXPORT_SYMBOL(clock_tve0_enaclock);
+EXPORT_SYMBOL(clock_tve1_enaclock);
+EXPORT_SYMBOL(clock_sdio_enaclock);
+EXPORT_SYMBOL(clock_audiopll_enaclock);
+EXPORT_SYMBOL(clock_jpeg_enaclock);
+EXPORT_SYMBOL(clock_coda_enaclock);
+EXPORT_SYMBOL(clock_df_enaclock);
+EXPORT_SYMBOL(clock_gpu_enaclock);
+EXPORT_SYMBOL(clock_ahb2_enaclock);
+EXPORT_SYMBOL(clock_crypto_enaclock);
+EXPORT_SYMBOL(clock_xport_enaclock);
+EXPORT_SYMBOL(clock_audio_enaclock);
+EXPORT_SYMBOL(clock_video_enaclock);
+EXPORT_SYMBOL(clock_dramporta_enaclock);
+EXPORT_SYMBOL(clock_usb_enaclock);
+EXPORT_SYMBOL(clock_cec_enaclock);
+EXPORT_SYMBOL(clock_ir_enaclock);
+EXPORT_SYMBOL(clock_vpb_enaclock);
+EXPORT_SYMBOL(clock_vpbinput_enaclock);
+EXPORT_SYMBOL(clock_cpu_enaclock);
+EXPORT_SYMBOL(clock_cpusrc_enaclock);
+EXPORT_SYMBOL(clock_hdmi_enaclock);
+
+static long cs_pwr_ioctl( struct file *file, unsigned int cmd, unsigned long arg)
+{
+	unsigned long flags;
+	char *name;
+    int pid_this;
+	name = ioctl_name(cmd);
+    pid_this = current->pid;
+	printk(KERN_INFO "(pid %d) %s: ioctl 0x%x{%s}(%lu)\n", pid_this, __func__, cmd, name, arg);
+	switch (cmd) {
+		case USB_POWER_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_usb_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case XPORT_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_xport_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case VPB_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_vpb_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case AUD_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_audio_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case CRYPTO_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_crypto_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case GRAPHICS_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_gpu_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case DF_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_df_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case VIDECOD_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_coda_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case SD_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_sdio_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case TVE1_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_tve1_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case TVE0_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_tve0_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case VDAC0_POWER_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_dac0_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case VDAC1_POWER_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_dac1_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+		case VID_POWER_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+            clock_video_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+            break;
+		case AUD_PLLCLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+            clock_audiopll_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+            break;
+		/* Pretend to do these, since they don't seem to be supported any more (at least not
+		   in the way they were on the 1800L). */
+		case AUDDACIF_CLK_DOWN:
+		case AUD_POWER_DOWN:
+			break;
+		case HDMI_POWER_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+			clock_hdmi_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+        case JPEG_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+            clock_jpeg_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+        case AHB2_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+            clock_ahb2_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+        case CEC_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+            clock_cec_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+			break;
+        case IR_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+            clock_ir_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+            break;
+        case VPBIN_CLK_DOWN:
+			spin_lock_irqsave(&cnc_pwr_lock, flags);
+            clock_vpbinput_enaclock(arg);
+			spin_unlock_irqrestore(&cnc_pwr_lock, flags);
+            break;
+		default:
+			return -EINVAL;
+	}
+	return 0;
+}
+
+static struct class *cnc_powerctl_class;
+static struct proc_dir_entry *power_proc_entry = NULL;
+static struct file_operations cnc_powerctl_fops = {
+	.owner	= THIS_MODULE,
+	.unlocked_ioctl		= cs_pwr_ioctl,
+};
+
+static int power_proc_write(struct file *file, const char __user *buffer,
+			   unsigned long count, void *data)
+{
+	int cmd_length;
+	const char *cmd_line = buffer;
+
+	cmd_length = strlen(cmd_line);
+
+	if (strncmp("dumpreg",cmd_line,7) == 0) {
+		unsigned int count = 0;
+
+		for(count = 0; count < 0x400; count +=4){
+			switch(count){
+				case 0x0:
+					printk("\n CLOCK_ID_BASE\n");
+					break;
+				case 0x100:
+					printk("\n CLOCK_PLL_BASE\n");
+					break;
+				case 0x140:
+					printk("\n CLOCK_MUX_BASE\n");
+					break;
+				case 0x200:
+					printk("\n CLOCK_RESET_BASE\n");
+					break;
+				case 0x300:
+					printk("\n PLL_PARA_BASE\n");
+					break;
+				case 0x350:
+					printk("\n VDAC_BASE\n");
+					break;
+				case 0x360:
+					printk("\n CPU_PWR_BASE\n");
+					break;
+			}
+			printk(" addr[0x%08x] = 0x%08x \n", CNC1900_ID_SCS + count, power_clk_read(CNC1900_ID_SCS+count));
+		}
+	}
+	else if(strncmp("dac0_enable",cmd_line,11) == 0){
+		printk("dac0_enable\n");
+		clock_dac0_enaclock(1);
+	}
+	else if(strncmp("dac0_disable",cmd_line,12) == 0){
+		printk("dac0_disable\n");
+		clock_dac0_enaclock(0);
+	}
+	else if(strncmp("dac1_enable",cmd_line,11) == 0){
+		printk("dac1_enable\n");
+		clock_dac1_enaclock(1);
+	}
+	else if(strncmp("dac1_disable",cmd_line,12) == 0){
+		printk("dac1_disable\n");
+		clock_dac1_enaclock(0);
+	}
+
+	return count;
+}
+
+#define POWER_CLOCK_MAJOR 500
+static int __init
+cnc1900_power_clock_init(void)
+{
+	struct device *power_clk_device = NULL;
+	dev_t maj_min = MKDEV(POWER_CLOCK_MAJOR, 1);
+
+	if (NULL == power_clk_base) {
+		if (!(power_clk_base = (volatile unsigned char *)ioremap(CNC1900_ID_SCS, CLOCK_REG_SIZE))) {
+			printk(KERN_ERR "ERROR: cnc1900_clock_init ioremap failed\n");
+			return (-1);
+		}
+		// power_clk_base_ui = (volatile uint32_t *)power_clk_base;
+	}
+
+	if (register_chrdev(POWER_CLOCK_MAJOR, "cnc1900_powerctl", &cnc_powerctl_fops)){
+		iounmap((void *)power_clk_base);
+		printk(KERN_ERR "ERROR: cnc1900_clock_init register_chrdev failed\n");
+		return -ENODEV;
+	}
+
+	cnc_powerctl_class = class_create(THIS_MODULE,"cnc1900_powerctl");
+	if (IS_ERR(cnc_powerctl_class)){
+		printk(KERN_ERR "ERROR: cnc1900_clock_init class_create failed\n");
+		iounmap((void *)power_clk_base);
+		unregister_chrdev(POWER_CLOCK_MAJOR, "cnc_powerctl");
+		cnc_powerctl_class = NULL;
+		return -ENODEV;
+	}
+
+	power_clk_device = device_create(cnc_powerctl_class, NULL, maj_min, NULL, "cs_pwr");
+	if (IS_ERR(power_clk_device)) {
+		printk(KERN_ERR "ERROR: cnc1900_clock_init device_create failed\n");
+		iounmap((void *)power_clk_base);
+		class_destroy(cnc_powerctl_class);
+		unregister_chrdev(POWER_CLOCK_MAJOR, "cnc_powerctl");
+		cnc_powerctl_class = NULL;
+		return -ENODEV;
+	}
+
+	power_proc_entry = create_proc_entry("cnc_powerctl", 0, NULL);
+	if (NULL != power_proc_entry) {
+		power_proc_entry->write_proc = power_proc_write;
+	}
+	else{
+		iounmap((void *)power_clk_base);
+		device_destroy(cnc_powerctl_class, maj_min);
+		class_destroy(cnc_powerctl_class);
+		unregister_chrdev(POWER_CLOCK_MAJOR, "cnc_powerctl");
+		printk(KERN_ERR "ERROR: cnc1900_power_clock_init create_proc_entry failed\n");
+		return (-1);
+	}
+
+	printk("cnc1900_power_clock_init done.\n");
+	return 0;
+}
+
+static void __exit
+cnc1900_power_clock_exit(void)
+{
+	dev_t maj_min = MKDEV(POWER_CLOCK_MAJOR, 1);
+	iounmap((void *)power_clk_base);
+	device_destroy(cnc_powerctl_class, maj_min);
+	class_destroy(cnc_powerctl_class);
+	unregister_chrdev(POWER_CLOCK_MAJOR, "cnc_powerctl");
+
+	if (NULL != power_proc_entry){
+		remove_proc_entry("cnc_powerctl", NULL);
+	}
+	printk("cnc1900_power_clock_exit done.\n");
+	return;
+}
+
+postcore_initcall(cnc1900_power_clock_init);
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/cnc19xx.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/cnc19xx.c
